#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
struct tree {
       tree *left ;
       int  key ;
       tree *right ;
} ;
void input (tree **);
int  menu_select();
void insert(tree **, int);
int  search (struct tree *, int);
void inorder (tree *s);
void deleteNode(tree **start, int item);
void search2(tree **root, int item, int *found,
	     tree **locptr, tree **parent);
int main ()
{
    tree *start = NULL;
    int num;
    while (1)  {
	clrscr();
	switch(menu_select())  {
	  case 1:

		 input(&start) ;
		 break ;
	  case 2:
		 printf("Enter number to search:");
		 scanf("%d", &num);
		 if(search(start, num))
		    printf("Number found.");
		 else
		    printf("Number not found.");
		 getch() ;
		 break ;
	  case 3:
		 clrscr() ;
		 printf("\n Traverse tree in inorder:\n");
		 inorder(start) ;
		 getch();
		 break ;
	  case 4:
		 printf("Enter number to delete:");
		 scanf("%d", &num);
		 deleteNode(&start, num);
		 break ;
	  case 5:
		 exit(0) ;
	} //end of switch
    } //end of while
}//end of main
//**********************
void input (tree **start)
{
    int num;
    while(1)
    {
      printf("Enter a number:");
      scanf("%d", &num);
      if(!num)
	  break;
      insert(start, num);
    } //end while
}
//***********************
int menu_select()
{
   int choice ;
   char s[5] ;
   printf("1- Enter a number in tree.\n");
   printf("2- Search a number in tree.\n");
   printf("3- Print information on screen.\n") ;
   printf("4- delete an item.\n");
   printf("5- Quit from program.\n") ;

   do {
       printf("Enter your select(1-5):");
       gets(s) ;
       choice = atoi(s) ;
   }  while (choice < 0 || choice > 5);
   return choice ;
}
//**************************
void insert(struct tree **root, int num)
{
   tree *node, *help ;
   help = *root;
   node = (tree *)malloc(sizeof(struct tree));
   node -> left = node -> right = NULL;
   node -> key = num;
   if(*root == NULL)
      *root = node;
    else
    {
      while (help != NULL)
      {
	if(node -> key > help ->key)
	{
	  if (help -> right != NULL)
		help = help -> right ;
	  else {
	      help -> right=node ;
	      break ;
	  }//end of else
	} //end of if
	else  {
	    if (help -> left != NULL )
		   help = help -> left ;
	    else  {
		 help -> left=node ;
		 break ;
	    } //end of else
	}  //end of else
      }//end of while
   }//end else
}
//**********************
int search (tree *s, int num)
{
   tree *h = s;
   while(h != NULL)
   {
      if( num < h -> key)
	  h = h -> left;
      else if(num > h ->key)
	 h = h -> right;
      else return 1;
    }
    return 0;
}
//*************************
void inorder (tree *s)
{
    if(s)
    {
       inorder(s -> left) ;
       printf("%d  ", s -> key);
       inorder(s -> right) ;
    }
}
//******************
void deleteNode(tree **root, int item)
{
  int found;
  tree *x, *parent, *xSucc, *subtree;
  search2(root, item, &found, &x, &parent);
  if(!found)
  {
      printf("item not found in BST.");
      return;
  }
  if(x -> left != NULL && x -> right != NULL)
  {    //node has two children
       //Find x's successor and its parent
       xSucc = x -> right;
       parent = x;
       while(xSucc -> left != 0)  //descend left
       {
	  parent = xSucc;
	  xSucc = xSucc -> left;
       }
       //Move contents of xSucc to x and change x
       //to point to successor, wich will be deleted.
       x -> key = xSucc -> key;
       x = xSucc;
  }//end of if
  //Now proceed with case where node has 0 or 1 child
  subtree = x -> left;   //point to a subtree of x
  if(subtree == NULL)
     subtree = x -> right;
  if(parent == NULL)     //root being deleted
      (*root) = subtree;
  else if(parent -> left == x) //left child of parent
      parent -> left = subtree;
  else           //right child of parent
      parent -> right = subtree;
  free(x);
} //end of deleteNode()
//********************
void search2(tree **root, int item, int *found,
	     tree **locptr, tree **parent)
{
   *locptr = *root;
   *parent = NULL;
   *found = 0;
   for(;;)
   {
       if((*found) || *locptr == NULL)
	  return;
       if(item < (*locptr) -> key)    //descend left
       {
	  *parent = *locptr;
	  *locptr = (*locptr) -> left;
       }
       else if(item > (*locptr) -> key) //descend right
       {
	  *parent = *locptr;
	  *locptr = (*locptr) -> right;
       }
       else
	  (*found) = 1;
   }
}





